#include "ValidateExe.mqh"
#include "ValidatePortfolio.mqh"

class VALIDATE
{
private:
  const bool IsTester;

  string PrevTesterSettings;

  VALIDATEPORTFOLIO ValidatePortfolio;
  VALIDATEEXE ValidateExe;

public:
  VALIDATE( const string sFolderName, const string sOutSampleSymbol = "", const int iMaxPasses = 0, const string sConstParameters = NULL ) :
            IsTester(::MQLInfoInteger(MQL_TESTER)), ValidatePortfolio(sFolderName),
            ValidateExe(sFolderName, sOutSampleSymbol, iMaxPasses,
                        (!this.IsTester && MTTESTER::GetSettings2(this.PrevTesterSettings)) ? this.PrevTesterSettings : NULL,
                        sConstParameters)
  {
    if (!this.IsTester)
    {
      uchar Bytes[];

      if (::StringToCharArray(this.PrevTesterSettings, Bytes) > 0)
        ::FileSave(sFolderName + "Done\\InitSettings.ini", Bytes);
    }
  }

  ~VALIDATE( void )
  {
    if (!IsTester)
      MTTESTER::SetSettings2(this.PrevTesterSettings);
  }

  void OnTimer()
  {
    if (this.ValidateExe.IsFinish())
      this.ValidatePortfolio.OnTimer();
    else
      this.ValidateExe.OnTimer();

    return;
  }

  bool IsFinish() const
  {
    return(this.ValidateExe.IsFinish() && this.ValidatePortfolio.IsFinish());
  }

  void OnTick()
  {
    if (this.ValidateExe.IsFinish())
      this.ValidatePortfolio.OnTick();

    return;
  }

  void OnChartEvent( const int id, const long &lparam, const double &dparam, const string &sparam )
  {
    if (this.ValidateExe.IsFinish())
      this.ValidatePortfolio.OnChartEvent(id, lparam, dparam, sparam);

    return;
  }
};